import "./index.css";
import '@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css';
import * as GC from "@grapecity/spread-sheets"

import { testPainting, testCalculation, testFlags, testIncrementlLaoding, testItrativeCal, testNamedStyle, testStaticFormulas, testCondionalFormatting } from "./performanceUtil"

var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));


function initSpread(spread: any) {

}
// window["ss"] = spread
addEvents(spread)
function addEvents(spread: any) {

    // painting test
    document.querySelector("#painting button#with").addEventListener("click", () => testPainting(spread, true));
    document.querySelector("#painting button#without").addEventListener("click", () => testPainting(spread, false));
    //calculation test
    document.querySelector("#calculation button#without").addEventListener("click", () => testCalculation(spread, false));
    document.querySelector("#calculation button#with").addEventListener("click", () => testCalculation(spread, true));
    document.querySelector("#calculation button#with").addEventListener("click", () => testCalculation(spread, true));
    //testFlags
    document.querySelector("#testFlags button#with").addEventListener("click", () => testFlags(spread, ["calcOnDemand"]));
    document.querySelector("#testFlags button#without").addEventListener("click", () => testFlags(spread, undefined));

    //incr mental laoding test
    document.querySelector("#incrementalLoading button#with").addEventListener("click", () => testIncrementlLaoding(spread, true));
    document.querySelector("#incrementalLoading button#without").addEventListener("click", () => testIncrementlLaoding(spread, false));

    //tesing the itartive calculationa
    document.querySelector("#circularDependency button#with").addEventListener("click", () => testItrativeCal(spread, true));
    document.querySelector("#circularDependency button#without").addEventListener("click", () => testItrativeCal(spread, false));

    //test named style
    document.querySelector("#namedStyle button#with").addEventListener("click", () => testNamedStyle(spread, true));
    document.querySelector("#namedStyle button#without").addEventListener("click", () => testNamedStyle(spread, false));

    //test static formulas

    document.querySelector("#staticFormulas button#with").addEventListener("click", () => testStaticFormulas(spread, true));
    document.querySelector("#staticFormulas button#without").addEventListener("click", () => testStaticFormulas(spread, false));


    //effect of arra formulas
    document.querySelector("#conditionalFormatting button#with").addEventListener("click", () => testCondionalFormatting(spread, true));
    document.querySelector("#conditionalFormatting button#without").addEventListener("click", () => testCondionalFormatting(spread, false));

    // reseting the spread after chaning the tab
    document.addEventListener('tabChanged', (e) => {
        spread.destroy();
        spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 1 });
        document.querySelector(".grid-item.with.value").textContent = "";
        document.querySelector(".grid-item.without.value").textContent = "";
    });
}


// let old = GC.Spread.Sheets.Worksheet.prototype.fromJSON;
// GC.Spread.Sheets.Worksheet.prototype.fromJSON = function () {
//     console.time("timeTaken");
//     old.apply(this, arguments);
//     console.timeEnd("timeTaken")
// }